/***************************************************************************
 *   Copyright (C) 2008  Antony Martin <martin(dot)antony(at)yahoo(dot)fr> *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or         *
 *   modify it under the terms of the GNU General Public License           *
 *   as published by the Free Software Foundation; either version 2        *
 *   of the License, or (at your option) any later version.                *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA          *
 ***************************************************************************/

/* Cree le : 28/02/2008
   derniere modification : 28/02/2008 */

#include <SCE/utils/SCEPlane.h>

static float a = 0.0f;

/* ajoute le 28/02/2008 */
void SCE_Plane_Init (SCE_SPlane *p)
{
    SCE_Vector3_Set (p->n, 0., 0., 0. /* 1. ? */);
    p->d = 0.;
}

/* ajoute le 28/02/2008 */
void SCE_Plane_Set (SCE_SPlane *p, float x, float y, float z, float d)
{
    SCE_Vector3_Set (p->n, x, y, z);
    p->d = d;
}
void SCE_Plane_Setv (SCE_SPlane *p, SCE_TVector3 n, float d)
{
    SCE_Vector3_Copy (p->n, n);
    p->d = d;
}

#if 0
/* ajoute le 28/02/2008 */
void SCE_Plane_SetFromPoint (SCE_SPlane *p, SCE_TVector3 n,
                             float x, float y, float z)
{
}
void SCE_Plane_SetFromPointv (SCE_SPlane*, SCE_TVector3, SCE_TVector3)
{
}
#endif

/* ajoute le 28/02/2008 */
void SCE_Plane_Normalize (SCE_SPlane *p, int normalize_distance)
{
    if (!normalize_distance)
        SCE_Vector3_Normalize (p->n);
    else
    {
        a = SCE_Vector3_Length (p->n);
        SCE_Vector3_Operator1 (p->n, /=, a);
        p->d /= a;
    }
}

/* ajoute le 28/02/2008 */
float SCE_Plane_DistanceToPoint (SCE_SPlane *p, float x, float y, float z)
{
    return p->n[0]*x + p->n[1]*y + p->n[2]*z + p->d;
}
float SCE_Plane_DistanceToPointv (SCE_SPlane *p, SCE_TVector3 v)
{
    return SCE_Vector3_Dot (p->n, v) + p->d;
}
